var b_width = 16;
var b_height = 8;

var bmap = new Array(b_width)

for (i=0;i<b_width;i++)
{
	bmap[i] = new Array(b_height);
	for (j=0;j<b_height;j++)
	{
		bmap[i][j] = new Object();
		bmap[i][j].tile = 0;
		bmap[i][j].obstruct = 0;
		bmap[i][j].marked = "";
		bmap[i][j].def = 0;
	}
}

var walk_sound = LoadSound("walk.wav");
var sword_sound = LoadSound("sword2.wav");
var arrow_sound = LoadSound("arrow2.wav");
var monst_sound = LoadSound("thud1.wav");

var max_units = 12;
var units = new Array(12);
for (i=0;i<12;i++)
{
	units[i] = new Object();
	if (i<6)
		units[i].x = 0;
	else
		units[i].x = b_width-1;

	units[i].y = i%6+Math.floor(b_height/2)-3;
	
	units[i].hp = 0;
	units[i].atk = 0;
	units[i].def = 0;
	units[i].type = i%6;
	units[i].dir = 0;
	units[i].frame = 0;
	units[i].attacks = 1;
	units[i].moves = 3;
	units[i].range = 1;
	units[i].hptype = "Men";
}



var tileset = new Array(10);

tileset[0] = LoadImage("sprites/grass.png");
tileset[1] = LoadImage("sprites/tree.png");

tileset[2] = LoadImage("sprites/fort_n.png");
tileset[3] = LoadImage("sprites/fort_ne.png");
tileset[4] = LoadImage("sprites/fort_e.png");
tileset[5] = LoadImage("sprites/fort_se.png");
tileset[6] = LoadImage("sprites/fort_s.png");
tileset[7] = LoadImage("sprites/fort_sw.png");
tileset[8] = LoadImage("sprites/fort_w.png");
tileset[9] = LoadImage("sprites/fort_nw.png");
tileset[10] = LoadImage("sprites/fort_fortified.png");

var g_raid = -1;

function StartBattle(attacker, defender, troops_attacking, raid, monster_a,monster_d)
{
	g_raid = -1;
	


	if (areas[defender].owner != g_player)

	if (monster_a == true)
	{
		if (factions[areas[attacker].owner].unit_use > 0)
			factions[areas[attacker].owner].unit_use--;
		else
		  monster_a = false;
	}
	if (monster_d == true)
	{
		if (factions[areas[defender].owner].unit_use > 0)
			factions[areas[defender].owner].unit_use--;
		else
		  monster_d = false;
	}



	if (areas[attacker].owner != g_player && areas[defender].owner != g_player)
	{
		AutoResolve();
		return;
	}


	var comp_retreat = 0;
	if (Math.random()<0.5)
	  comp_retreat = 1;

	var spritesets = new Array(19);
	for (ii = 0;ii<19;ii++)
	{
		spritesets[ii] = new Array(4);
		for (ij = 0;ij<4;ij++)
		{
			spritesets[ii][ij] = new Array(3);
		}
	} 
	
	var ss_temp = "";
	
	if (areas[attacker].owner == g_player)
		var bplayer = 0;
	else
		var bplayer = 6;
	
	for (ii=0;ii<19;ii++)
	{
		if (ii >16)
		{
			ss_temp = "foot";

			if (ii == 17 && monster_a == true)
				ss_temp = GetMonster(areas[attacker].owner);
			else if (ii == 18 && monster_d == true)
				ss_temp = GetMonster(areas[defender].owner);
		}
		else if (ii%6 == 0)
			ss_temp = "foot";
		else if (ii%6 == 1)
			ss_temp = "archer";
		else if (ii%6 == 2)
			ss_temp = "horsemen";
		else if (ii%6 == 5)
		{
			ss_temp = "foot";
			if (ii == 5 && monster_a == true)
				ss_temp = GetMonster(areas[attacker].owner);
			else if (ii == 11 && monster_d == true)
				ss_temp = GetMonster(areas[defender].owner);
		}


		if (ii< 6)
		{
			spritesets[ii][0][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_1.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][0][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_2.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][0][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_3.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
	
			spritesets[ii][1][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_1.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][1][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_2.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][1][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_3.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
	
			spritesets[ii][2][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_1.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][2][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_2.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][2][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_3.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
	
			spritesets[ii][3][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_1.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][3][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_2.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
			spritesets[ii][3][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_3.png", factions[areas[attacker].owner].colour);//CreateColor(255,0,0,255));
		}
		else if (ii<12)
		{
			spritesets[ii][0][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_1.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][0][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_2.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][0][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_3.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
	
			spritesets[ii][1][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_1.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][1][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_2.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][1][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_3.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
	
			spritesets[ii][2][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_1.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][2][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_2.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][2][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_3.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
	
			spritesets[ii][3][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_1.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][3][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_2.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
			spritesets[ii][3][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_3.png", factions[areas[defender].owner].colour);//CreateColor(0,0,255,255));
		}
		else
		{
			spritesets[ii][0][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_1.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][0][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_2.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][0][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_north_3.png", CreateColor(128,128,128,255),ii);
	
			spritesets[ii][1][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_1.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][1][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_2.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][1][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_east_3.png", CreateColor(128,128,128,255),ii);
	
			spritesets[ii][2][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_1.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][2][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_2.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][2][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_south_3.png", CreateColor(128,128,128,255),ii);
	
			spritesets[ii][3][0] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_1.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][3][1] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_2.png", CreateColor(128,128,128,255),ii);
			spritesets[ii][3][2] = SpecialLoad("sprites/"+ss_temp+"/"+ss_temp+"_west_3.png", CreateColor(128,128,128,255),ii);
		}
	}
	
	var xoff = 32;
	var yoff = 16;


	var brounds = 1;
	var unit_selected = -1;
	var bmouse = LoadImage("mouse1.png");

	function SpecialLoad(file, colour,number)
	{
		var sprite = LoadSurface(file);
		var pixel;
		var average = 0;

		if (number != 17 && number != 18)
		{
			for (i=0;i<16;i++)
			{
				for (j=0;j<16;j++)
				{
					pixel = sprite.getPixel(i,j);
					if (pixel.red == 255 && pixel.green == 255 && pixel.blue == 255&& pixel.alpha == 255)
						sprite.setPixel(i,j, CreateColor(colour.red, colour.green, colour.blue, 255));
					else if (pixel.red == 200 && pixel.green == 200 && pixel.blue == 200&& pixel.alpha == 255)
						sprite.setPixel(i,j, CreateColor(colour.red/2, colour.green/2, colour.blue/2, 255));
				}
			}
		}
		else
		{
			//just grayscale it
			for (i=0;i<16;i++)
			{
				for (j=0;j<16;j++)
				{
					pixel = sprite.getPixel(i,j);
					if (pixel.alpha == 255)
					{
						average = Math.floor(pixel.red+pixel.green+pixel.blue)/3;
						sprite.setPixel(i,j, CreateColor(average, average, average, pixel.alpha));
					}
				}
			}
		}
		return sprite.createImage();
	}
	
	//set up the sprite sets
	//set up the map
	//set up start the loop
	
	//units:
		//-footsoldiers (2)
		//-archers (2)
		//-horsemen (1)
		//-beast (1)
		
	var bend = LoadImage("b_end1.png");
	var bretreat = LoadImage("b_retreat1.png");

	var booly = false;

	function DrawBattleMap(unit, xoff3,yoff3)
	{
		var xoff2 = 0;
		var yoff2 = 0;
		var cross = 4000;
		//handle music
		if (music[2].getPosition() > music[2].getLength()-cross)
		{
			if (music[4].isPlaying() != true)
			{
				music[4].stop();
				music[4].setPosition(0);
				music[4].play(true);
			}
			
			music[2].setVolume(music_vol[2]*((music[2].getLength()-music[2].getPosition())/cross));
			music[4].setVolume(music_vol[4]-music_vol[4]*((music[2].getLength()-music[2].getPosition())/cross));
			booly = true;
		}
		
		if (music[2].isPlaying() == false && booly == true)
		{
			if (music[4].isPlaying() != true)
			{
				music[4].stop();
				music[4].setPosition(0);
				music[4].play(true);
			}
			
			booly = false
			music_current = 4;
			music[4].setVolume(music_vol[4]);
		}
	
		for (i1=0;i1<b_width;i1++)
		{
			for (j1=0;j1<b_height;j1++)
			{
				tileset[bmap[i1][j1].tile].blit(i1*16+xoff, j1*16+yoff);
				if (bmap[i1][j1].marked == "a" && bmap[i1][j1].marked2 == true)
					Rectangle(i1*16+xoff, j1*16+yoff, 16,16,CreateColor(255,0,0,200));
				else if (bmap[i1][j1].marked != "" && bmap[i1][j1].marked2 == true)
					Rectangle(i1*16+xoff, j1*16+yoff, 16,16,CreateColor(0,0,255,200));
				else if (unit_selected > -1)
				{
					if (i1 == units[unit_selected].x && j1 == units[unit_selected].y)
					{
						Rectangle(i1*16+xoff, j1*16+yoff, 16,16,CreateColor(160,160,32,200));
					}
				}
			}
		}
		for (i1=0;i1<max_units;i1++)
		{
			if (units[i1].hp > 0)
			{
				if (i1 == unit)
				{
					xoff2 = xoff3;
					yoff2 = yoff3;
				}
				else
				{
					xoff2 = 0;
					yoff2 = 0;
				}
			
				if (units[i1].attacks > 0)
					spritesets[units[i1].spriteset][units[i1].dir][units[i1].frame].blit(units[i1].x*16+xoff+xoff2,units[i1].y*16+yoff+yoff2);
				else
				{
					if (i1 == 5)
						spritesets[17][units[i1].dir][units[i1].frame].blit(units[i1].x*16+xoff+xoff2,units[i1].y*16+yoff+yoff2);
					else if (i1 == 11)
						spritesets[18][units[i1].dir][units[i1].frame].blit(units[i1].x*16+xoff+xoff2,units[i1].y*16+yoff+yoff2);
					else
						spritesets[units[i1].spriteset%6+12][units[i1].dir][units[i1].frame].blit(units[i1].x*16+xoff+xoff2,units[i1].y*16+yoff+yoff2);
				}
			}
		}
		
	}

	function GenerateMap()
	{
		for (a=0;a<b_width;a++)
		{
			for (b=0;b<b_height;b++)
			{
				bmap[a][b].tile = 0;
				bmap[a][b].obstruct = 0;
				bmap[a][b].marked = "";
				bmap[a][b].def = 0;
			}
		}


		//!DONE!-place down fortification
		//!DONE!-place down trees
		//-place down river (if applicable)
		//-place down starting units
		
		if (areas[defender].fort <30 || raid!=false)
		{
			//no placements
		}
		else if (areas[defender].fort <60)
		{
			//tiny
			bmap[13][2].tile = 9;
			bmap[14][2].tile = 2;
			bmap[13][3].tile = 8;
			bmap[13][4].tile = 7;
			bmap[14][4].tile = 6;
			
			bmap[14][3].def = 1;
		}
		else if (areas[defender].fort <90)
		{
			//small
			bmap[13][2].tile = 9;
			bmap[14][2].tile = 2;
			bmap[13][3].tile = 8;
			bmap[13][4].tile = 8;
			bmap[14][3].tile = 10;
			bmap[13][5].tile = 7;
			bmap[14][5].tile = 6;
			
			bmap[14][3].def = 2;
			bmap[14][4].def = 1;
		}
		else if (areas[defender].fort <120)
		{
			//medium
			bmap[13][2].tile = 9;
			bmap[14][2].tile = 2;
			bmap[13][3].tile = 8;
			bmap[13][4].tile = 8;
			bmap[14][3].tile = 10;
			bmap[14][4].tile = 10;
			bmap[13][5].tile = 7;
			bmap[14][5].tile = 6;
			bmap[14][5].tile = 6;

			bmap[14][3].def = 2;
			bmap[14][4].def = 2;
		}
		else if (areas[defender].fort <160)
		{
			//large
			bmap[13][1].tile = 9;
			bmap[14][1].tile = 2;
//			bmap[14][1].tile = 2;
			bmap[12][2].tile = 9;
			bmap[13][2].tile = 5;
			bmap[12][3].tile = 8;
			bmap[13][3].tile = 10;
			bmap[14][3].tile = 10;
			bmap[13][4].tile = 10;
			bmap[12][4].tile = 8;
			bmap[12][5].tile = 7;
			bmap[13][5].tile = 3;
			bmap[13][6].tile = 7;
			bmap[14][6].tile = 6;
//			bmap[14][6].tile = 6;

			bmap[13][3].def = 2;
			bmap[14][3].def = 2;
			bmap[13][4].def = 2;
		}
		else if (areas[defender].fort <190)
		{
			//very large
			bmap[12][1].tile = 9;
			bmap[13][1].tile = 2;
			bmap[14][1].tile = 2;
//			bmap[14][1].tile = 2;
			bmap[12][2].tile = 8;
			bmap[12][3].tile = 8;
			bmap[12][4].tile = 8;
			bmap[12][5].tile = 8;
			bmap[13][2].tile = 10;
			bmap[13][3].tile = 10;
			bmap[13][4].tile = 10;
			bmap[13][5].tile = 10;
			bmap[12][6].tile = 7;
			bmap[13][6].tile = 6;
			bmap[14][6].tile = 6;
//			bmap[14][6].tile = 6;

			bmap[13][2].def = 2;
			bmap[13][3].def = 2;
			bmap[13][4].def = 2;
			bmap[13][5].def = 2;
		}
		else if (areas[defender].fort <210)
		{
			//very large
			bmap[11][1].tile = 9;
			bmap[12][1].tile = 2;
			bmap[13][1].tile = 2;
			bmap[14][1].tile = 3;
			bmap[11][2].tile = 8;
			bmap[14][2].tile = 7;
			bmap[11][3].tile = 8;
			bmap[11][4].tile = 8;
			bmap[11][5].tile = 8;
			bmap[14][5].tile = 9;
			bmap[12][2].tile = 10;
			bmap[12][3].tile = 10;
			bmap[12][4].tile = 10;
			bmap[12][5].tile = 10;
			bmap[11][6].tile = 7;
			bmap[12][6].tile = 6;
			bmap[13][6].tile = 6;
			bmap[14][6].tile = 5;

			bmap[13][3].tile = 10;

			bmap[12][2].def = 2;
			bmap[12][3].def = 2;
			bmap[12][4].def = 2;
			bmap[12][5].def = 2;
			bmap[13][3].def = 2;

		}
		else if (areas[defender].fort <240)
		{
			//fortress
			bmap[11][1].tile = 9;
			bmap[12][1].tile = 2;
			bmap[13][1].tile = 2;
			bmap[14][1].tile = 3;
			bmap[11][2].tile = 8;
			bmap[14][2].tile = 7;
			bmap[11][3].tile = 8;
			bmap[11][4].tile = 8;
			bmap[11][5].tile = 8;
			bmap[14][5].tile = 9;
			bmap[12][2].tile = 10;
			bmap[13][2].tile = 10;
			bmap[12][3].tile = 10;
			bmap[12][4].tile = 10;
			bmap[12][5].tile = 10;
			bmap[13][5].tile = 10;
			bmap[11][6].tile = 7;
			bmap[12][6].tile = 6;
			bmap[13][6].tile = 6;
			bmap[14][6].tile = 5;

			bmap[12][2].def = 2;
			bmap[13][2].def = 2;
			bmap[12][3].def = 2;
			bmap[12][4].def = 2;
			bmap[12][5].def = 2;
			bmap[13][5].def = 2;

		}
		else if (areas[defender].fort >=240)
		{
			//awesome
			bmap[11][1].tile = 9;
			bmap[12][1].tile = 2;
			bmap[13][1].tile = 2;
			bmap[14][1].tile = 3;
			bmap[11][2].tile = 8;
			bmap[14][2].tile = 7;
			bmap[11][3].tile = 8;
			bmap[11][4].tile = 8;
			bmap[11][5].tile = 8;
			bmap[14][5].tile = 9;
			bmap[12][2].tile = 10;
			bmap[12][3].tile = 10;
			bmap[12][4].tile = 10;
			bmap[12][5].tile = 10;
			bmap[13][2].tile = 10;
			bmap[13][3].tile = 10;
			bmap[13][4].tile = 10;
			bmap[13][5].tile = 10;
//			bmap[14][3].tile = 10;
//			bmap[14][4].tile = 10;
			bmap[11][6].tile = 7;
			bmap[12][6].tile = 6;
			bmap[13][6].tile = 6;
			bmap[14][6].tile = 5;


			bmap[12][2].def = 2;
			bmap[12][3].def = 2;
			bmap[12][4].def = 2;
			bmap[12][5].def = 2;
			bmap[13][2].def = 2;
			bmap[13][3].def = 2;
			bmap[13][4].def = 2;
			bmap[13][5].def = 2;
//			bmap[14][3].def = 2;
//			bmap[14][4].def = 2;

		}
		
		//now place the trees/rivers
		var tmax = 6+5*Math.random();
		for (i=0;i<tmax;i++)
		{
			PlaceTree(Math.floor((b_width-2)*Math.random()+1),Math.floor(b_height*Math.random()));
		}

		//now verify that there weren't any screw ups...
		for (a=0;a<b_width;a++)
		{
			for (b=0;b<b_height;b++)
			{
				if (bmap[a][b].tile == 1)
					VerifyPlaceTree(a,b);
			}
		}

		//now place down the players
		
		var troops = troops_attacking;
		
		for (i=0;i<12;i++)
		{
			if (i<6)
			{
				units[i].x = 1;
				units[i].dir = 1;
				units[i].frame = 0;
			}
			else
			{
				units[i].x = b_width-1;
				units[i].dir = 3;
				units[i].frame = 0;
			}
		
			units[i].attackedby=-1;
			units[i].attacking=-1;

			units[i].y = i%6+Math.floor(b_height/2)-3;

			units[i].target=-1;

			
			if (bmap[units[i].x][units[i].y].tile != 0)
				bmap[units[i].x][units[i].y].tile = 0
			
			if (i%6!=5)
			{
				if (i<6)
				{
					units[i].hp = Math.floor(troops/5);
					if (troops %5 > i%6)
						units[i].hp++;
				}
				else
				{
					units[i].hp = Math.floor(areas[defender].sold/5);
					if (areas[defender].sold %5 > i%6)
						units[i].hp++;
				}
					
				units[i].atk = 0;
				units[i].def = 0;
				units[i].type = 0;
				units[i].attacks = 1;



				if (i%6 <2)
					units[i].type = 0;
				else if (i==6+2)
					units[i].type = 1;
				else if (i==6+3)
					units[i].type = 1;
				else if (i==6+4)
					units[i].type = 2;
				else if (i%6 <4)
					units[i].type = 2;
				else if (i%6 <5)
					units[i].type = 1;

				if (units[i].type == 2)
					units[i].moves = 3;
				else 
					units[i].moves = 2;
					
				if (units[i].type == 1)
					units[i].range = 3;
				else 
					units[i].range = 1;
					
				if (i <5)
				{
					units[i].spriteset = units[i].type;
				}
				else if (i%6 <5)
				{
					units[i].spriteset = units[i].type+6;
				}
			}
			else
			{
				//beast unit
				//some basic default stuff
				if (i==5)
				{
					SetUnitInfo(i, areas[attacker].owner, monster_a);
				}
				else if (i==11)
				{
					SetUnitInfo(i, areas[defender].owner, monster_d);
				}
			}
		}
		
		//go through tiles and mark obstructions
		for (a=0;a<b_width;a++)
		{
			for (b=0;b<b_height;b++)
			{
				if (bmap[a][b].tile == 0 || bmap[a][b].tile == 10)
				{
					//grass or fortification
					bmap[a][b].obstruct = 0;
				}
				else
				{
					bmap[a][b].obstruct = 1;
				}
			}
		}
		
	}
	
	function PlaceTree(x,y)
	{
		if (CheckPosition(x,y))
			if (bmap[x][y].tile == 0)
				bmap[x][y].tile = 1;
	}
	
	function VerifyPlaceTree(x,y)
	{
		var counter=0;
		if (CheckPosition(x,y-1))
			if (bmap[x][y-1].tile != 0)
				counter+=bmap[x][y-1].tile;
		if (CheckPosition(x+1,y-1))
			if (bmap[x+1][y-1].tile != 0)
				counter+=bmap[x+1][y-1].tile;
		if (CheckPosition(x+1,y))
			if (bmap[x+1][y].tile != 0)
				counter+=bmap[x+1][y].tile;
		if (CheckPosition(x+1,y+1))
			if (bmap[x+1][y+1].tile != 0)
				counter+=bmap[x+1][y+1].tile;
		if (CheckPosition(x,y+1))
			if (bmap[x][y+1].tile != 0)
				counter+=bmap[x][y+1].tile;
		if (CheckPosition(x-1,y+1))
			if (bmap[x-1][y+1].tile != 0)
				counter+=bmap[x-1][y+1].tile;
		if (CheckPosition(x-1,y))
			if (bmap[x-1][y].tile != 0)
				counter+=bmap[x-1][y].tile;
		if (CheckPosition(x-1,y-1))
			if (bmap[x-1][y-1].tile != 0)
				counter+=bmap[x-1][y-1].tile;

		if (counter > 1)
			bmap[x][y].tile = 0;
	}

	function CheckPosition(x,y)
	{
		if (x < b_width && x>=0 && y<b_height && y>=0)
			return true;
		return false;
	}


	function BattleFadeIn()
	{
		PlayMusic(2);
		lasttime=GetTime();
		for (a=0;a<16*4;a++)
		{		
			DrawBattleMap();
			DrawGUI();
			Rectangle(0,0,320,240,CreateColor(0,0,0,255-255*(a/(16*4))));
	
			while (GetTime()-lasttime<1000/30);
			lasttime=GetTime();
			FlipScreen();
		}
	}

	function MainLoop()
	{
		GenerateMap();
		BattleFadeIn();
		while(b_win==-1)
		{
			if (b_win==-1)
			{
				MarkRadius(-1);
				unit_selected = -1;
				if (bplayer == 0)
					PromptBattleDisplay("Attackers' turn.");
				else
					PromptBattleDisplay("Defenders' turn.");
				PlayerTurn();
				CheckBattleEnd();
			}
			if (b_win==-1)
			{
				MarkRadius(-1);
				unit_selected = -1;
				if (bplayer == 6)
					PromptBattleDisplay("Attackers' turn.");
				else
					PromptBattleDisplay("Defenders' turn.");
				ComputerTurn();
				CheckBattleEnd();
			}
			if (b_win==-1)
				brounds++;
		}	


		//show a victory
		
		if (b_win == 0)
			PromptBattleDisplay("Defenders win!");
		else if (b_win == 1)
			PromptBattleDisplay("Attackers win!");
		else if (b_win == 2)
			PromptBattleDisplay("Attackers retreat!");
		else if (b_win == 3)
			PromptBattleDisplay("Defenders retreat!");
			
		//adjust area's ownership, troops, etc.
		if (raid == false)
		{
			if (b_win == 0)
			{
				//defenders have own
				var sold = 0
				for (t=6;t<11;t++)
				{
					sold+=units[t].hp;
				}
				areas[defender].sold = sold;
			}
			else if (b_win == 1)
			{
				//attackers have own
				var sold = 0
				for (t=0;t<5;t++)
				{
					sold+=units[t].hp;
				}
				areas[defender].sold = sold;
				areas[defender].owner=areas[attacker].owner;
			}
			else if (b_win == 2)
			{
				//attackers have retreated
				var sold = 0
				for (t=6;t<11;t++)
				{
					sold+=units[t].hp;
				}
				areas[defender].sold = sold;
				
				sold=0;
				for (t=0;t<5;t++)
				{
					sold+=units[t].hp;
				}
				areas[attacker].sold+=sold;
				PromptBattleDisplay("Attackers fled back to area "+areas[attacker].name+".");
			}
			else if (b_win == 3)
			{
				//defenders have retreated
				var sold = 0
				for (t=0;t<5;t++)
				{
					sold+=units[t].hp;
				}
				areas[defender].sold = sold;
	
				sold = 0;
				for (t=6;t<11;t++)
				{
					sold+=units[t].hp;
				}
				var m = MapRetreat(defender, sold);
				if (m>-1)
					PromptBattleDisplay("Defenders fled to area "+areas[m].name+".");
				else
					PromptBattleDisplay("Defenders surrender.");
				areas[defender].owner=areas[attacker].owner;
			}
		}
		else
		{
			var sold = 0
			for (t=6;t<11;t++)
			{
				sold+=units[t].hp;
			}
			areas[defender].sold = Math.ceil(areas[defender].sold/2+sold/2);

			sold = 0;
			for (t=0;t<5;t++)
			{
				sold+=units[t].hp;
			}
				
			areas[attacker].sold += Math.ceil(troops_attacking/2)+Math.ceil(sold/2);

			if (b_win == 0)
			{
				//defenders have own
				g_raid = 0;
				PromptBattleDisplay("Defenders have repelled the raid.");
			}
			else if (b_win == 1)
			{
				//attackers have own
				//take money

				g_raid = 1;
				PromptBattleDisplay("Attackers plunder the region.");
				areas[attacker].gold+=Math.ceil(areas[defender].gold/2);
				areas[defender].gold-=Math.ceil(areas[defender].gold/2);
			}
			else if (b_win == 2)
			{
				g_raid = 0;
				//attackers have retreated
				PromptBattleDisplay("Attackers have called off the raid.");
			}
			else if (b_win == 3)
			{
				g_raid = 1;
				//defenders have retreated
				PromptBattleDisplay("Defenders yield.  Region plundered.");
				areas[attacker].gold+=Math.ceil(areas[defender].gold/2);
				areas[defender].gold-=Math.ceil(areas[defender].gold/2);
			}
			
			if (areas[attacker].gold > gold_max)
				areas[attacker].gold = gold_max;
			if (areas[defender].gold < 0)
				areas[defender].gold = 0;
		}

		lasttime=GetTime();
		for (a=0;a<16*4;a++)
		{		
			FadeMusic(a/(16*4));
			DrawBattleMap();
			DrawGUI();
			Rectangle(0,0,320,240,CreateColor(0,0,0,255*(a/(16*4))));
	
			while (GetTime()-lasttime<1000/30);
			lasttime=GetTime();
			FlipScreen();
		}
	}
	
	bend_x = 12;
	bend_y = 240-16-12+2;
	bretreat_x = 320-bretreat.width-12;
	bretreat_y = 240-16-12+2;

	var raid_string = "";

	function DrawGUI(stringy)
	{
		window2.drawWindow(xoff+4,4,320-8-2*xoff,yoff-8);
		window.drawWindow(12,8*16+yoff+12+32,320-24,240-(8*16+yoff)-24-32);
		if (raid == true)
			raid_string = "Raid of region ("+areas[defender].name+")";
		else
			raid_string = "Invasion of region ("+areas[defender].name+")";
			
		font.drawText(160-font.getStringWidth(raid_string)/2, 8*16+yoff+12+32+4, raid_string);

		window2.drawWindow(xoff+4,8*16+yoff+4,320-8-2*xoff,yoff-8+16+1);

		if (stringy != undefined)
			font.drawText(xoff+4,8*16+yoff+4+12, stringy);


		font.drawText(160-font.getStringWidth("Round 00")/2, 2, "Round "+brounds);


		//draw the selected unit's hp and movement points;
		if (unit_selected > -1)
		{
			if (unit_selected %6 != 5)
				font.drawText(xoff+4,8*16+yoff+4, "Men Remaining: "+units[unit_selected].hp);
			else 
				font.drawText(xoff+4,8*16+yoff+4, units[unit_selected].hptype+" Remaining: "+units[unit_selected].hp);
			font.drawText(xoff+4+128,8*16+yoff+4, "Movement Points: "+units[unit_selected].moves);
		}

		for (i1=0;i1<6;i1++)
		{
			if (units[i1].hp > 0)
			{
				spritesets[units[i1].spriteset][1][0].blit(0,2+i1*28);
				font2.drawText(0,2+i1*28+16, units[i1].hp);
			}
			if (units[i1+6].hp > 0)
			{
				spritesets[units[i1+6].spriteset][3][0].blit(320-16,2+i1*28);
				font2.drawText(320-8*((units[i1+6].hp+"").length),2+i1*28+16, units[i1+6].hp);
			}
		}

		bend.blit(bend_x,bend_y);
		bretreat.blit(bretreat_x,bretreat_y);

		//draw the mouse
		bmouse.blit(GetMouseX(),GetMouseY());

	}
	
	var tpx = 0;
	var tpy = 0;
	
	function MarkRadius(num, fort, attacking)
	{
		for (i=0;i<b_width;i++)
		{
			for (j=0;j<b_height;j++)
			{
				bmap[i][j].marked = "";
				bmap[i][j].marked2 = false;
			}
		}
		
		if (num == -1)
			return;

		if (attacking == undefined)
			attacking = -1;
		
		var m_array = new Array();
		var m_array2 = new Array();
		var m_length = 1;
		var m_length2 = 1;

		m_array[0] = units[num].x+units[num].y*b_width;
		var trounds = 0;

		while(m_length > 0)
		{
			m_length2 = 0;
			for (j=0; j<m_length; j++)
			{
				if (trounds<units[num].moves)
					MarkNearby(m_array[j], undefined, attacking);
				else
					MarkNearby(m_array[j],false, attacking);
			}
			
			m_length = m_length2;
			for (j=0;j<m_length2;j++)
			{
			  m_array[j] = m_array2[j];
			}
			trounds++;
		}
		
		function MarkNearby(number, marky, attacking)
		{
			var tmx = number%b_width;
			var tmy = Math.floor(number/b_width);
			
			if (tmx>0)
			{
				if (Test(tmx-1,tmy, attacking))
				{
					bmap[tmx-1][tmy].marked = "e";
					if (marky == false)
						bmap[tmx-1][tmy].marked2 = false;
					else
						bmap[tmx-1][tmy].marked2 = true;
					
					m_array2[m_length2]=tmx-1+tmy*b_width;
					m_length2++;
				}
			}
			if (tmx < b_width-1)
			{
				if (Test(tmx+1,tmy, attacking))
				{
					bmap[tmx+1][tmy].marked = "w";
					if (marky == false)
						bmap[tmx+1][tmy].marked2 = false;
					else
						bmap[tmx+1][tmy].marked2 = true;

					m_array2[m_length2]=tmx+1+tmy*b_width;
					m_length2++;
				}
			}

			if (tmy>0)
			{
				if (Test(tmx,tmy-1, attacking))
				{
					bmap[tmx][tmy-1].marked = "s";
					if (marky == false)
						bmap[tmx][tmy-1].marked2 = false;
					else
						bmap[tmx][tmy-1].marked2 = true;

					m_array2[m_length2]=tmx+(tmy-1)*b_width;
					m_length2++;
				}
			}
			
			if (tmy < b_height-1)
			{
				if (Test(tmx,tmy+1, attacking))
				{
					bmap[tmx][tmy+1].marked = "n";
					if (marky == false)
						bmap[tmx][tmy+1].marked2 = false;
					else
						bmap[tmx][tmy+1].marked2 = true;

					m_array2[m_length2]=tmx+(tmy+1)*b_width;
					m_length2++;
				}
			}
		}
		
		function Test(x,y, attacking)
		{
			if (bmap[x][y].obstruct==1 || bmap[x][y].marked != "")
			  return false;
			for (mt=0;mt<12;mt++)
			{
				if (attacking == mt);
				else if (units[mt].x==x && units[mt].y==y && units[mt].hp > 0)
					return false;
			}
			return true;
		}
	
		if (num > 5 && units[num].type == 1 && units[num].hp > 0 && bmap[units[num].x][units[num].y].def == 2)
		{
			units[num].range = 4;
		}
		for (mt=0;mt<12;mt++)
		{
			if (units[mt].hp>0 && units[num].attacks > 0)
			{
				if ((mt<6 && num >5) || (mt>5 && num < 6))
				{
					
					if (BattleDistance(units[num].x, units[num].y, units[mt].x,units[mt].y)<=units[num].range)
					{
					  bmap[units[mt].x][units[mt].y].marked = "a";
					  bmap[units[mt].x][units[mt].y].marked2 = true;
					}
				}
			}
		}
		if (units[num].type == 1)
		{
			units[num].range = 3;
		}


	}

	function BattleDistance(x,y,x2,y2)
	{
		return (Math.abs(x-x2)+Math.abs(y-y2));
	}

	function PromptBattleDisplay(string)
	{
		var lasttime = GetTime();
		var ml_pressed = true;
		var count = 0;
		var pbframes = 0;
		
		while(true)
		{
			DrawBattleMap();
			DrawGUI(string.substr(0,count));
			pbframes++;
			
			if (count<string.length)
			{
				if (pbframes%2 == 0)
					count++;
			}

			while (GetTime()-lasttime<1000/30);
			FlipScreen();
			lasttime=GetTime();
			
			if(!IsMouseButtonPressed(MOUSE_LEFT))
				ml_pressed = false;
				
			if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
			{
				ml_pressed = true;

				if (count<string.length)
					count = string.length;
				else
					return;
			}
			
			while(AreKeysLeft())
			{
				GetKey();
				if (count<string.length)
					count = string.length;
				else
					return;
			}
		}
	}


	function PlayerTurn()
	{
		MarkRadius(-1);
		unit_selected = -1;

		for (t=0;t<12;t++)
		{
			ResetMoves(t);
		}
	
		var lasttime = GetTime();
		var ml_pressed = true;
		
		while(b_win == -1)
		{
			DrawBattleMap();
			DrawGUI();

			while (GetTime()-lasttime<1000/30);
			lasttime=GetTime();
			FlipScreen();
			
			if(!IsMouseButtonPressed(MOUSE_LEFT))
				ml_pressed = false;
				
			if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
			{
				ml_pressed = true;
				if (IsMouseInBox(bend_x, bend_y, bend.width, bend.height))
				{
					PlaySound(1);
					return;
				}
				else if (IsMouseInBox(bretreat_x, bretreat_y, bretreat.width, bretreat.height))
				{
					PlaySound(1);
					if (bplayer == 0)
						b_win = 2;
					else
						b_win = 3;
				}
				else if (unit_selected == -1)
				{
					//see if the mouse is over a player's unit
					tpx = Math.floor((GetMouseX()-xoff)/16);
					tpy = Math.floor((GetMouseY()-yoff)/16);
					
					for (i=0;i<12;i++)
					{
						if (units[i].x == tpx && units[i].y == tpy && units[i].hp > 0)
						{
							break;
						}
					}
					
					if (i<12)
					{
						PlaySound(1);
						unit_selected = i;

						MarkRadius(-1);
						if ((bplayer == 0 && unit_selected < 6) || (bplayer == 6 && unit_selected>5))
							MarkRadius(unit_selected);
					}
				}
				else if ((bplayer == 0 && unit_selected < 6) || (bplayer == 6 && unit_selected>5))
				{
					tpx = Math.floor((GetMouseX()-xoff)/16);
					tpy = Math.floor((GetMouseY()-yoff)/16);
					//see if the mouse clicked on a coloured tile
					if (tpx>=0 &&tpx<b_width &&tpy>=0 &&tpy<b_height)
					{
						if (bmap[tpx][tpy].marked == "a")
						{
								//attack this unit
							for (t=0;t<12;t++)
							{
								if (tpx == units[t].x && tpy == units[t].y && units[t].hp > 0)
								{
									AttackUnit(unit_selected,t);
									MarkRadius(-1);
									unit_selected = -1;
								}	
							}
						}
						else if (bmap[tpx][tpy].marked != "")
						{
							//move
							MoveUnitTo(unit_selected, tpx,tpy);
							MarkRadius(-1);
							unit_selected = -1;
						}
						else
						{
//							PlaySound(1);
							//deselect
							MarkRadius(-1);
							unit_selected = -1;
						}
					}
				}
				else
				{
					MarkRadius(-1);
					unit_selected = -1;
				}
				
				if (bplayer == 0)
				{
					
				}
			}
			
			while(AreKeysLeft())
			{
				switch(GetKey())
				{
					case KEY_ESCAPE:
					{
						return;
					}
					case KEY_ENTER:
					{
						return;
					}
				}	
			}
		}
	}


	function MoveUnitTo(unit, zx,zy)
	{
		var counter = 0;
		path = "";
		while((zx != units[unit].x || zy !=units[unit].y) && counter < 100)
		{
			path = bmap[zx][zy].marked+path;
			if (bmap[zx][zy].marked == "e")
				zx++;
			else if (bmap[zx][zy].marked == "w")
				zx--;
			else if (bmap[zx][zy].marked == "s")
				zy++;
			else if (bmap[zx][zy].marked == "n")
				zy--;
			counter++;
		}
		
		if (counter < 100)
		{
			//move along the path
			for (l=0;l<path.length;l++)
			{
				MoveUnit(unit, path.charAt(l));
			}
		}
	}

	function MoveUnitCloseTo(unit, zx,zy)
	{
		var counter = 0;
		path = "";
		var ctx =zx;
		var cty =zy;
		
		while((zx != units[unit].x || zy !=units[unit].y) && counter < 100)
		{
			path = bmap[zx][zy].marked+path;
			if (bmap[zx][zy].marked == "e")
				zx++;
			else if (bmap[zx][zy].marked == "w")
				zx--;
			else if (bmap[zx][zy].marked == "s")
				zy++;
			else if (bmap[zx][zy].marked == "n")
				zy--;
			counter++;
		}
		
		if (counter < 100)
		{
			//move along the path
			for (l=0;l<path.length;l++)
			{
				if (BattleDistance(units[unit].x, units[unit].y, ctx,cty) > units[unit].range)
					MoveUnit(unit, path.charAt(l));
			}
		}
	}


	function MoveUnit(unit, dir)
	{
		if (units[unit].type == 1)
		{
			units[unit].range = 3;
		}


		if (units[unit].hp<=0)
		{
			MarkRadius(-1);
			return;
		}
		if (units[unit].moves > 0)
			units[unit].moves--;
		else
			return;
				
		walk_sound.stop();
		walk_sound.setPosition(0);
		walk_sound.play(false);
		var ym = 0;
		var xm = 0;

		if (dir == "e")
		{
			units[unit].dir = 3;
			xm = -1;
		}
		else if (dir == "w")
		{
			units[unit].dir = 1;
			xm = 1;
		}
		else if (dir == "s")
		{
			units[unit].dir = 0;
			ym = -1;
		}
		else if (dir == "n")
		{
			units[unit].dir = 2;
			ym = 1;
		}
	
		//have a sound play;
		var lasttimey = GetTime();
		var frame_wait = 1;
		for (mut=0;mut<16;mut++)
		{
			if (mut<4)
				units[unit].frame = 1;
			else if (mut<8)
				units[unit].frame = 0;
			else if (mut<12)
				units[unit].frame = 2;
			else 
				units[unit].frame = 0;
				
				
			for (k=0;k<frame_wait;k++)
			{
				DrawBattleMap(unit,mut*xm, mut*ym);
				DrawGUI();
	
				while (GetTime()-lasttimey<1000/30);
				FlipScreen();
				while(AreKeysLeft())GetKey();
			}
		}

		units[unit].x+=xm;
		units[unit].y+=ym;
		units[unit].frame = 0;
	}

	function AttackUnit(attacker,defender)
	{
		if (attacker >= 0 && defender >=0);
		else
		{
			DrawBattleMap();
			font.drawText(0,0, attacker);
			font.drawText(0,20, defender);
			FlipScreen();
			GetKey();
			return;
		}
	
		if ((attacker < 6 && defender > 5)||(attacker >5 && defender <6))
		{
			if (units[attacker].hp > 0 &&units[defender].hp > 0)
			{
				if (units[attacker].attacks > 0)
				{
					if (attacker > 5 && units[attacker].type == 1 && units[attacker].hp > 0 && bmap[units[attacker].x][units[attacker].y].def == 2)
					{
						units[attacker].range = 4;
					}
				
				
					if (BattleDistance(units[attacker].x, units[attacker].y, units[defender].x, units[defender].y)<= units[attacker].range)
					{
						if (units[attacker].type == 1)
						{
							arrow_sound.stop();
							arrow_sound.setPosition(0);
							arrow_sound.play(false);
						}
						else if (units[attacker].type == 5)
						{
							monst_sound.stop();
							monst_sound.setPosition(0);
							monst_sound.play(false);
						}
						else
						{
							sword_sound.stop();
							sword_sound.setPosition(0);
							sword_sound.play(false);
						}

					
					
						FaceUnit(attacker,defender);

						//compute damage amount
						if (units[attacker].type == 0 ||units[attacker].type == 2)
							var damage = units[attacker].hp/5;//foot/horse
						else if (units[attacker].type == 1)
							var damage = units[attacker].hp/7;//archer
						else 
							var damage = units[attacker].hp/4;//beast
						
						var side = 0;
						if (units[attacker].dir==units[defender].dir)
						{
							damage*=1.5;//Rear Attack
							side = 1;
						}
						else if (units[attacker].dir!=(units[defender].dir+2)%4)
						{
							damage*=1.25;//Flank Attack
							side = 2;
						}
						
						var charge = 0;
						//charge bonus:
						if (units[attacker].type == 2 && units[attacker].moves == 0)
						{
							charge = 1;
							damage*=1.25;
						}
						
						//random modifier;
						damage= (0.8+0.4*Math.random())*damage;
						
						var fort = 0;
						if (defender > 5 && attacker<6)
						{
							if (bmap[units[defender].x][units[defender].y].def == 2)
							{
								fort = 1;
								damage = damage/2;
							}
						}
						
						
						
						damage = Math.ceil(damage);
						
							if (side == 2)
								PromptBattleDisplay("Flank attack!");
							else if (side == 1)
								PromptBattleDisplay("Rear attack!");

							if (charge == 1)
								PromptBattleDisplay("Charge attack!");

							if (fort == 1)
								PromptBattleDisplay("Fortified position!");

							PromptBattleDisplay("Did "+damage+" damage!");
							if (units[defender].hp < damage)
							{
								PromptBattleDisplay("Unit destroyed!");
							}

						if (defender > 5 && units[defender].type == 1 && units[defender].hp > 0 && bmap[units[defender].x][units[defender].y].def == 2)
						{
							units[defender].range = 4;
						}

						//counter attack stuff
						if (BattleDistance(units[attacker].x, units[attacker].y, units[defender].x, units[defender].y)<=1)
						{
							if (units[defender].type == 1)
								var d_damage = units[defender].hp/7;//archer
							else
								var d_damage = units[defender].hp/5;

							//random modifier;
							d_damage= (0.8+0.4*Math.random())*d_damage;
							
							d_damage = Math.ceil(d_damage);
	
	
							PromptBattleDisplay("Suffered "+d_damage+" in casualities.");
							units[attacker].hp -=d_damage;
							if (units[attacker].hp < 0)
							{
								units[attacker].hp =0
								PromptBattleDisplay("Unit Loss!");
							}
						}
							
						if (units[defender].type == 1)
						{
							units[defender].range = 3;
						}
						
						units[defender].hp -=damage;
						if (units[defender].hp < damage)
						{
							units[defender].hp =0
							PromptBattleDisplay("Unit destroyed!");
						}

						units[attacker].attacks--;
						if (units[attacker].attacks<=0)
							units[attacker].attacks=0;
						units[attacker].moves =0;

						units[defender].attackedby=attacker;
						units[attacker].attacking=defender;
						
						//check battle conditions here.
						CheckBattleEnd();
					}
				
					if (units[attacker].type == 1)
						units[attacker].range = 3;
				}
			}
		}
	}

	var b_win = -1;

	function CheckBattleEnd()
	{
		a_count = 0;
		d_count = 0;
		for (a=0;a<12;a++)
		{
			if (units[a].hp > 0)
			{
				if (a<6)
					a_count++;
				else
					d_count++;
			}
		}
		if (a_count == 0)
		{
			//either a tie, or defenders won;
			b_win = 0;
		}
		else if (d_count == 0)
		{
			//attackers won.
			b_win = 1;
		}
	}


	function FaceUnit(unit,num)
	{
		var fx = units[num].x-units[unit].x;
		var fy = -units[num].y+units[unit].y;
		
		if (fy <= fx && fy >= -1*fx)//east
			units[unit].dir = 1;
		else if (fy <= fx && fy <= -1*fx)//south
			units[unit].dir = 2;
		else if (fy >= fx && fy >= -1*fx)//north
			units[unit].dir = 0;
		else if (fy >= fx && fy <= -1*fx)//west
			units[unit].dir = 3;
	}
	
	function ResetMoves(num)
	{
		if (num == 5)
			SetUnitInfo(5, areas[attacker].owner, true,false);
		else if (num == 11)
			SetUnitInfo(11, areas[defender].owner, true,false);
		else if (units[num].type == 2)
			units[num].moves = 5;
		else
			units[num].moves = 3;
		
			
		units[num].attacks = 1;
	}

	function ComputerTurn()
	{
		/*
			-if defending
				-go through each unit that the computer has.
				-go through the archers first, and search 
				 for the nearest fortified area, and failing
				 that, defensive area
				-go through the rest of the units and go to
				 a fortified area, or just wait.
				-beast unit should have special ai.
			-if attacking
				-advance all units at roughly the same speed.
				-attack:
					-closest unit: archers, footsoldiers
					-weakest unit: beasts, horsemen.
			-at the end, if an enemy is nearby, 
			 attack them.
		*/
		MarkRadius(-1);
		unit_selected = -1;
		
		if (comp_retreat==1 && Math.random() > 0.33)
		{
			var asold = 0;
			var dsold = 0;
			
			for (ct=0;ct<6;ct++)
			{
				asold+=units[ct].hp;
				dsold+=units[ct+6].hp;
			}
			
			if (bplayer == 0)
			{
				if (asold> 5*dsold)
				{
					//computer retreats
					b_win = 3;
					return;
				}
			}
			else
			{
				if (dsold> 5*asold)
				{
					//computer retreats
					b_win = 2;
					return;
				}
			}
		}
		
		
		for (t=0;t<12;t++)
		{
			ResetMoves(t);
		}
		
		var closest = 1000;
		var closest_x = 0;
		var closest_y = 0;
		var ctarget = -1;
		


		if (bplayer == 0)
		{
			//defending
			for (t=6;t<12;t++)
			{
				if (units[t-bplayer].type == 1 && units[t-bplayer].hp > 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def < 1)
				{
					//go to a far away fortified area.
					MarkRadius(t-bplayer, false);
					
					closest = -1;
					closest_x = 0;
					closest_y = 0;

					for (a=0;a<b_width;a++)
					{
						for (b=0;b<b_height;b++)
						{
							if (bmap[a][b].marked != "" && bmap[a][b].def == 2)
							{
								if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b) > closest)
								{
									closest = BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b);
									closest_x = a;
									closest_y = b;
								}
							}
						}
					}
					
					if (closest >-1)
						MoveUnitTo(t-bplayer, closest_x,closest_y);
					else
					{
						closest = -1;
						closest_x = 0;
						closest_y = 0;
	
						for (a=0;a<b_width;a++)
						{
							for (b=0;b<b_height;b++)
							{
								if (bmap[a][b].marked != "" && bmap[a][b].def == 1)
								{
									if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b) > closest)
									{
										closest = BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b);
										closest_x = a;
										closest_y = b;
									}
								}
							}
						}
						if (closest > -1)
							MoveUnitTo(t-bplayer, closest_x,closest_y);
					}
				}
			}

			for (t=6;t<12;t++)
			{
				if (units[t-bplayer].type != 1 && units[t-bplayer].hp > 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def < 1)
				{
					//go to nearest fortified area.
					MarkRadius(t-bplayer, false);
					
					closest = -1;
					closest_x = 0;
					closest_y = 0;
	
					for (a=0;a<b_width;a++)
					{
						for (b=0;b<b_height;b++)
						{
							if (bmap[a][b].marked != "" && bmap[a][b].def == 2)
							{
								if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b) > closest)
								{
									closest = BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b);
									closest_x = a;
									closest_y = b;
								}
							}
						}
					}
						
					if (closest > -1)
						MoveUnitTo(t-bplayer, closest_x,closest_y);
					else
					{
						closest = -1;
						closest_x = 0;
						closest_y = 0;
		

						for (a=0;a<b_width;a++)
						{
							for (b=0;b<b_height;b++)
							{
								if (bmap[a][b].marked != "" && bmap[a][b].def == 1)
								{
									if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b) > closest)
									{
										closest = BattleDistance(units[t-bplayer].x, units[t-bplayer].y, a,b);
										closest_x = a;
										closest_y = b;
									}
								}
							}
						}
						if (closest > -1)
							MoveUnitTo(t-bplayer, closest_x,closest_y);
					}
				}
			}
		}
		else
		{
			
			for (t=6;t<12;t++)
			{
/*			
			font.drawText(0,0, "HELLO "+t);
			FlipScreen();
			GetKey();
			GetKey();
*/
				if (units[t-bplayer].hp > 0)
				{
					if (units[t-bplayer].target != -1)
					{
						MarkRadius(t-bplayer,false);
					
						if (units[units[t-bplayer].target].hp <=0 || !IsUnitReachable(units[t-bplayer].target))
							units[t-bplayer].target = FindTarget(t-bplayer);

					}
					else
						units[t-bplayer].target = FindTarget(t-bplayer);
				}
			}

			for (t=6;t<12;t++)
			{
				if (units[t-bplayer].attacks > 0 && units[t-bplayer].hp > 0)
				{
					if (units[t-bplayer].target >= 0)
					{
						MarkRadius(t-bplayer, undefined, units[t-bplayer].target);

						MoveUnitCloseTo(t-bplayer, units[units[t-bplayer].target].x,units[units[t-bplayer].target].y);
							
						if (units[t-bplayer].type == 1 && t-bplayer > 5 && units[t-bplayer].hp > 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def == 2)
							units[t-bplayer].range = 4;
	
						if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, units[units[t-bplayer].target].x, units[units[t-bplayer].target].y) <= units[t-bplayer].range)
						{
							MarkRadius(t-bplayer);
							unit_selected = t-bplayer;
							AttackUnit(t-bplayer, units[t-bplayer].target);
							if (b_win >-1)
								return;
						}
						if (units[t-bplayer].type == 1)
							units[t-bplayer].range = 3;

					}
				}
			}
		}
		
		//handle those that you are attacking
		for (t=6;t<12;t++)
		{
			if (units[t-bplayer].attacking >= 0 && units[t-bplayer].hp > 0)
			{

				if (units[t-bplayer].type == 1 && t-bplayer > 5 && units[t-bplayer].hp > 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def == 2)
					units[t-bplayer].range = 4;

				if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, units[units[t-bplayer].attacking].x, units[units[t-bplayer].attacking].y) <= units[t-bplayer].range)
				{
					MarkRadius(t-bplayer);
					unit_selected = t-bplayer;
					AttackUnit(t-bplayer, units[t-bplayer].attacking);
					if (b_win >-1)
						return;
				}

				if (units[t-bplayer].type == 1)
					units[t-bplayer].range = 3;
			}
		}
			

		for (t=6;t<12;t++)
		{
			if (units[t-bplayer].attacking > -1 && units[t-bplayer].hp > 0)
			{
				if (units[t-bplayer].type == 1 && t-bplayer > 5 && units[t-bplayer].hp > 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def == 2)
					units[t-bplayer].range = 4;
	

				if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, units[units[t-bplayer].attacking].x, units[units[t-bplayer].attacking].y) <= units[t-bplayer].range)
				{
					MarkRadius(t-bplayer);
					unit_selected = t-bplayer;
					AttackUnit(t-bplayer, units[t-bplayer].attacking);
					if (b_win >-1)
						return;
				}

				if (units[t-bplayer].type == 1)
					units[t-bplayer].range = 3;

			}
				
			if (units[t-bplayer].attacks > 0)
			{
				if (units[t-bplayer].attackedby >= 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def == 0)
				{
					MarkRadius(t-bplayer, undefined, units[t-bplayer].attackedby);
							
					MoveUnitCloseTo(t-bplayer, units[units[t-bplayer].attackedby].x,units[units[t-bplayer].attackedby].y);

					if (units[t-bplayer].type == 1 && t-bplayer > 5 && units[t-bplayer].hp > 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def == 2)
						units[t-bplayer].range = 4;
					
					if (BattleDistance(units[t-bplayer].x, units[t-bplayer].y, units[units[t-bplayer].attackedby].x, units[units[t-bplayer].attackedby].y) <= units[t-bplayer].range)
					{
						MarkRadius(t-bplayer);
						unit_selected = t-bplayer;
						AttackUnit(t-bplayer, units[t-bplayer].attackedby);
						if (b_win >-1)
							return;
					}
					if (units[t-bplayer].type == 1)
						units[t-bplayer].range = 3;
				}
			}
		}
		
		//anything left?
	

			//if you have attack points left, attack nearyby units;
		for (t=6;t<12;t++)
		{
			if (units[t-bplayer].attacks > 0 && units[t-bplayer].hp > 0)
			{
				for (abt=0;abt<6;abt++)
				{
					if (units[t-bplayer].type == 1 && t-bplayer > 5 && units[t-bplayer].hp > 0 && bmap[units[t-bplayer].x][units[t-bplayer].y].def == 2)
						units[t-bplayer].range = 4;

					if (BattleDistance(units[abt+bplayer].x, units[abt+bplayer].y, units[t-bplayer].x, units[t-bplayer].y) <= units[t-bplayer].range)
					{
						MarkRadius(t-bplayer);
						unit_selected = t-bplayer;
						AttackUnit(t-bplayer,abt+bplayer);
						if (b_win >-1)
							return;
						//break;
					}

					if (units[t-bplayer].type == 1)
						units[t-bplayer].range = 3;
				}
			}
		}
	}

	function FindTarget(num)
	{
		var shortest = 1000;
		var s_unit=-1
		
		MarkRadius(num,false);
		
		for (a=0;a<6;a++)
		{
			if (units[a+bplayer].hp>0)
			{
				if (units[num].type != 2)
				{
					if (units[a+bplayer].hp > 0 && BattleDistance(units[num].x, units[num].y, units[a+bplayer].x, units[a+bplayer].y) < shortest)
					{
						if (IsUnitReachable(a+bplayer))
						{
							s_unit = a+bplayer;
							shortest = BattleDistance(units[num].x, units[num].y, units[a+bplayer].x, units[a+bplayer].y);
						}
					}
				}
				else
				{
					if (units[a+bplayer].hp> 0 && units[a+bplayer].hp < shortest)
					{
						if (IsUnitReachable(a+bplayer))
						{
							s_unit = a+bplayer;
							shortest = units[a+bplayer].hp;
						}
					}
				}
			}
		}
		return s_unit;
	}

	function IsUnitReachable(number)
	{
		var tpx = units[number].x;
		var tpy = units[number].y;
	
		if (tpx > 0)
		{
			if (bmap[tpx-1][tpy].marked != "")
				return true;
		}
		else if (tpx <b_width-1)
		{
			if (bmap[tpx+1][tpy].marked != "")
				return true;
		}
		else if (tpy > 0)
		{
			if (bmap[tpx][tpy-1].marked != "")
				return true;
		}
		else if (tpy <b_height-1)
		{
			if (bmap[tpx][tpy+1].marked != "")
				return true;
		}

		return false;
	}
	
	function FindNearestFort(dude)
	{
			
	
	
	}

	function AutoResolve()
	{
		var attacking_e = 0;
		var defending_e = 0;
		if (monster_a)
			attacking_e+=150;
		if (monster_d)
			defending_e+=150;
	
		if (raid == false)
		{
			if (areas[defender].sold+defending_e + Math.random()*areas[defender].fort/2+areas[defender].fort/2< (troops_attacking+attacking_e)*(0.75+0.5*Math.random()))
			{
				//attackers win;
				if (troops_attacking-areas[defender].sold-areas[defender].fort/2 < 0)
					areas[defender].sold = Math.floor(troops_attacking/4);
				else if (troops_attacking-areas[defender].sold-areas[defender].fort/2 < troops_attacking/4)
					areas[defender].sold = Math.floor(troops_attacking/2);
				else 
					areas[defender].sold = Math.floor(3*troops_attacking/4);
					
				areas[defender].owner = areas[attacker].owner;
			}
			else
			{
				//defenders win;
				if (areas[defender].sold+areas[defender].fort/2-troops_attacking < 0)
					areas[defender].sold = Math.floor(areas[defender].sold/4);
				else if (areas[defender].sold+areas[defender].fort/2-troops_attacking < areas[defender].sold/4)
					areas[defender].sold = Math.floor(areas[defender].sold/2);
				else 
					areas[defender].sold = Math.floor(3*areas[defender].sold/4);
			}
			
			areas[defender].fort -= Math.floor(troops_attacking/7);
		}
		else
		{
			
			if (areas[defender].sold+defending_e+(areas[defender].sold+defending_e)*0.4*Math.random() < troops_attacking+attacking_e)
			{
				g_raid = 1;
				//attackers win;
				if (areas[defender].sold+areas[defender].fort/2-troops_attacking < 0)
					areas[attacker].sold+= Math.floor(troops_attacking/2);
				else if (areas[defender].sold+areas[defender].fort/2-troops_attacking < areas[defender].sold/4)
					areas[attacker].sold+= Math.floor(3*troops_attacking/4);
				else 
					areas[attacker].sold+= Math.floor(6*troops_attacking/7);

				areas[attacker].gold+=Math.ceil(areas[defender].gold/2);
				areas[defender].gold-=Math.ceil(areas[defender].gold/2);
			}
			else
			{
				g_raid = 0;
				//defenders win;
				if (areas[defender].sold+areas[defender].fort/2-troops_attacking < 0)
					areas[defender].sold = Math.floor(areas[defender].sold/2);
				else if (areas[defender].sold+areas[defender].fort/2-troops_attacking < areas[defender].sold/4)
					areas[defender].sold = Math.floor(3*areas[defender].sold/4);
				else 
					areas[defender].sold = Math.floor(6*areas[defender].sold/7);
			}
		}

			
		if (areas[attacker].gold > gold_max)
			areas[attacker].gold = gold_max;
		if (areas[defender].gold < 0)
			areas[defender].gold = 0;
	}


	function SetUnitInfo(n, fact, monster,hp)
	{
		if (monster == true)
		{
			if (factions[fact].unit == "Cthulhi Pirates")
			{
				if (hp!=false)
					units[n].hp=150;
				units[n].atk = 0;
				units[n].def = 0;
				units[n].type = 5;
				units[n].attacks = 1;
				units[n].moves = 3;
				units[n].range = 1;
				units[n].hptype = "Hp";
			}
			else if (factions[fact].unit == "Shantaks")
			{
				if (hp!=false)
					units[n].hp=125;
				units[n].atk = 0;
				units[n].def = 0;
				units[n].type = 5;
				units[n].attacks = 1;
				units[n].moves = 5;
				units[n].range = 1;
				units[n].hptype = "Hp";
			}
			else if (factions[fact].unit == "Flying Polyps")
			{
				if (hp!=false)
					units[n].hp=75;
				units[n].atk = 0;
				units[n].def = 0;
				units[n].type = 5;
				units[n].attacks = 1;
				units[n].moves = 5;
				units[n].range = 5;
				units[n].hptype = "Hp";
			}
			else if (factions[fact].unit == "Bhole")
			{
				if (hp!=false)
					units[n].hp=250;
				units[n].atk = 0;
				units[n].def = 0;
				units[n].type = 5;
				units[n].attacks = 1;
				units[n].moves = 1;
				units[n].range = 1;
				units[n].hptype = "Hp";
			}
			else if (factions[fact].unit == "Gugs")
			{
				if (hp!=false)
					units[n].hp=200;
				units[n].atk = 0;
				units[n].def = 0;
				units[n].type = 5;
				units[n].attacks = 1;
				units[n].moves = 2;
				units[n].range = 1;
				units[n].hptype = "Hp";
			}
			else if (factions[fact].unit == "Crawling Ones")
			{
				if (hp!=false)
					units[n].hp=140;
				units[n].atk = 0;
				units[n].def = 0;
				units[n].type = 5;
				units[n].attacks = 1;
				units[n].moves = 4;
				units[n].range = 1;
				units[n].hptype = "Hp";
			}
			if (n<6)
				units[n].spriteset = 5;
			else
				units[n].spriteset = 11;
		}
		else
		{
			units[n].hp=150;
			units[n].hp=0;
			units[n].atk = 0;
			units[n].def = 0;
			units[n].type = 5;
			units[n].spriteset = 0;
			units[n].attacks = 1;
			units[n].moves = 2;
		}
	}



	MainLoop();



}