var farm_max = 255;
var mine_max = 255;
var tech_max = 255;
var fort_max = 255;

var gold_max = 9999;
var food_max = 9999;

function ImproveFarms(area)
{
	if (areas[area].gold < 5)
	{
		return 0;
	}

	OverDisplay(areas[area].name+" buys farms.", area);

	areas[area].gold-=5;
	areas[area].farm+=(3+Math.floor((areas[area].tech/10)*Math.random()));
	if (areas[area].farm > farm_max)
		areas[area].farm=farm_max;
	return 1;
}

function ImproveMines(area)
{
	if (areas[area].gold < 5)
	{
		return 0;
	}

	OverDisplay(areas[area].name+" buys mines.", area);

	areas[area].gold-=5;
	areas[area].mine+=(g_mine_base+Math.ceil((areas[area].tech/g_tech_influ)*Math.random()));
	if (areas[area].mine > mine_max)
		areas[area].mine=mine_max;
	return 1;
}

function ImproveTech(area)
{
	if (areas[area].gold < 5)
	{
		return 0;
	}

	OverDisplay(areas[area].name+" buys tech.", area);

	areas[area].gold-=5;
	areas[area].tech+=(g_tech_base+Math.floor(g_tech_rand*Math.random()));
	if (areas[area].tech > tech_max)
		areas[area].tech=tech_max;
	return 1;
}

function ImproveFort(area)
{
	if (areas[area].gold < 5)
	{
		return 0;
	}

	OverDisplay(areas[area].name+" buys fort.", area);

	areas[area].gold-=5;
	areas[area].fort+=(g_fort_base+Math.floor((areas[area].tech/g_tech_influ)*Math.random()));
	if (areas[area].fort > fort_max)
		areas[area].fort=fort_max;
	return 1;
}

function AutoImprove(area)
{
	if (g_round%4 == 1)
	{
		//tax collection
		areas[area].gold+=Math.floor(areas[area].mine*g_mine_harvest_g+areas[area].farm*g_farm_harvest_g+Math.floor(Math.random()*areas[area].tech*g_tech_harvest_g));
	}
	else if (g_round%4 == 3)
	{
		//harvest collection
		areas[area].food+=Math.floor(areas[area].farm*g_farm_harvest_f+Math.floor(Math.random()*areas[area].tech*g_tech_harvest_f));
	}

	areas[area].food-=Math.floor(areas[area].tech*g_tech_need_f*(0.5+Math.random()));


	areas[area].farm+=Math.floor(Math.random()*areas[area].tech*g_tech_improve);
	areas[area].mine+=Math.floor(Math.random()*areas[area].tech*g_tech_improve);
	areas[area].fort+=Math.floor(Math.random()*areas[area].tech*g_tech_improve);

	if (areas[area].food >= 0)
		areas[area].tech+=Math.floor(Math.random()*2);

	if (areas[area].farm > farm_max)
		areas[area].farm = farm_max;
	if (areas[area].mine > mine_max)
		areas[area].mine = mine_max;
	if (areas[area].fort > fort_max)
		areas[area].fort = fort_max;
	if (areas[area].tech > tech_max)
		areas[area].tech = tech_max;

	if (areas[area].food < 0)
	{
		areas[area].farm+=Math.floor(areas[area].food*g_farm_decrease-Math.floor(Math.random()*areas[area].tech*g_tech_decrease));
		areas[area].mine+=Math.floor(areas[area].food*g_mine_decrease-Math.floor(Math.random()*areas[area].tech*g_tech_decrease));
	
		if (areas[area].farm < 0)
			areas[area].farm = 0;
		if (areas[area].mine < 0)
			areas[area].mine = 0;
		if (areas[area].tech < 0)
			areas[area].tech = 0;
	
		areas[area].food = 0;
	}

	AutoDistribute(area);
}

function BuyTroops(amount, area)
{
	OverDisplay(areas[area].name+" buys "+amount+" sold.",area);

	if (amount < 0)
		return;
	amount = Math.floor(amount);

	if (areas[area].gold < amount)
		amount = areas[area].gold;

	var solds = Math.floor(amount/g_troop_cost);
	if (areas[area].owner != g_player)
	{
		if (g_diff == 2)
			areas[area].gold-=Math.ceil(solds*g_troop_cost/2);
		else if (g_diff == 0)
			areas[area].gold-=Math.ceil(solds*g_troop_cost*1.5);
		else if (g_diff == 1)
			areas[area].gold-=Math.ceil(solds*g_troop_cost);
	}
	else
		areas[area].gold-=solds*g_troop_cost;
	areas[area].sold+=solds;
}

function MoveTroops(amount, area, target)
{
	OverDisplay(areas[area].name+" send "+amount+" sold to "+areas[target].name+".",area);

	if (amount <0)
		return;
	amount = Math.floor(amount);

	if (areas[area].sold < amount)
		amount = areas[area].sold;

	areas[area].sold-=amount;
	areas[target].sold+=amount;
}

function AttackTroops(amount, area, target, monster)
{
	var target_fact = areas[target].owner;

	if (amount < 0)
		return;
		
	if (monster == true)
	{
		if (factions[areas[area].owner].unit_use > 0);
		else
		  monster = false;
	}
	
	
		
	//Show a prompt for attack
	if (areas[target].owner > -1)
		PromptOverDisplay(area, target, factions[areas[area].owner].name+" ("+areas[area].name+")"+" invades "+factions[areas[target].owner].name+" ("+areas[target].name+")!");
	else
		PromptOverDisplay(area, target, factions[areas[area].owner].name+" ("+areas[area].name+")"+" invades area "+areas[target].name+"!");


//defending creature use
	var monsterd = false;
	if (areas[target].owner > -1)
	{
		if (factions[areas[target].owner].unit_use > 0 && areas[target].owner != g_player)
		{
			monsterd = true;
		}
	}
//prompt player about using their creature
	if (areas[target].owner>-1)
	{
		if (areas[target].owner == g_player)
		{
			if (factions[g_player].unit_use > 0)
			{
				if (PromptCreatureUse(g_player))
					monsterd = true;
				else
					monsterd = false;
			}
		}
		else if (areas[area].owner == g_player)
		{
			if (factions[g_player].unit_use > 0)
			{
				if (PromptCreatureUse(g_player,area))
					monster = true;
				else
					monster = false;
			}
		}
	}


	if (areas[area].sold < amount)
		amount = areas[area].sold;
	amount = Math.floor(amount);

	areas[area].sold-=amount;
	

	if (areas[area].owner != areas[target].owner && areas[target].owner > -1)
	{
		factions[areas[target].owner].hate[areas[area].owner] += amount;
		factions[areas[area].owner].hate[areas[target].owner] += Math.floor(amount/2);
	}



	if (areas[target].owner > -1)
	{
		amount = DoBattle(amount, area, target,false, monster,monsterd);
		
		if (areas[area].owner == areas[target].owner)
		{
			areas[target].auto_gold = 0;
			areas[target].auto_food = 0;
			factions[target_fact].hate[areas[area].owner]+=1000;
			factions[areas[area].owner].hate[target_fact]+=250;

			PromptOverDisplay(area, target, "Invasion succeeds.");

			for (at=0;at<max_factions;at++)
			{
				if (at != areas[area].owner)
				{
					if (factions[at].allied[target_fact] == -1)
					{
						factions[at].hate[areas[area].owner] -=250;
						factions[areas[area].owner].hate[at] -=250;
					}
					else if (factions[at].allied[target_fact] == 1)
					{
						factions[at].hate[areas[area].owner] +=500;
						factions[areas[area].owner].hate[at] +=250;
					}
				}
			}
		}
		else
		{
			PromptOverDisplay(area, target, "Invasion repelled.");
		}
	}
	else
	{
		PromptOverDisplay(area, target, "Province occupied.");

		//just occupy it
			areas[target].auto_gold = 0;
			areas[target].auto_food = 0;
		areas[target].owner = areas[area].owner;
		areas[target].sold = amount;
	}	
}

function DoBattle(amount, area, target,raid, monster_a, monster_d)
{
	if (areas[area].owner > -1 && areas[target].owner > -1)
	{
		if (factions[areas[area].owner].allied[areas[target].owner] == 1)
		{
			//hurt rep
			factions[areas[target].owner].hate[areas[area].owner]+=2000;
			
		}
	
		factions[areas[area].owner].allied[areas[target].owner] = -1;
		factions[areas[target].owner].allied[areas[area].owner] = -1;
	}

	if (amount < 0)
		return;
		
	var tempp = false;
	if (areas[area].owner == g_player || areas[target].owner == g_player)
	{
		tempp = true;
		FadeOverOut();
	}

	StartBattle(area, target, amount, raid,monster_a,monster_d);

	if (tempp)
	{
			PlayMusic(1);
			FadeOverOut("in");
	}

	if (areas[area].owner == areas[target].owner && raid)
	{
		areas[target].auto_gold = 0;
		areas[target].auto_food = 0;

	}

/*
	if (Math.random()<0.5 && 1==2)
	{
		//lose
		amount = 0;
		areas[target].sold = Math.floor(areas[target].sold/2);
	}
	else
	{
		amount = Math.floor(amount/2);
		//win
	}
*/
	return amount;
}


function RaidTroops(amount, area, target, monster)
{
	if (amount < 0)
		return;

	var gamount = 0;

	if (areas[area].sold < amount)
		amount = areas[area].sold;
	amount = Math.floor(amount);

	areas[area].sold-=amount;

	if (monster == true)
	{
		if (factions[areas[area].owner].unit_use > 0);
		else
		  monster = false;
	}

	
	if (areas[target].owner > -1)
		PromptOverDisplay(area, target, factions[areas[area].owner].name+" ("+areas[area].name+") "+"raids "+factions[areas[target].owner].name+" ("+areas[target].name+")!");
	else
		PromptOverDisplay(area, target, factions[areas[area].owner].name+" ("+areas[area].name+") "+"raids area "+areas[target].name+"!");

	var monsterd = false;
//prompt player about using their creature
	if (areas[target].owner>-1)
	{
		if (areas[target].owner == g_player)
		{
			if (factions[g_player].unit_use > 0)
			{
				if (PromptCreatureUse(g_player))
					monsterd = true;
				else
					monsterd = false;
			}
		}
		else if (areas[area].owner == g_player)
		{
			if (factions[g_player].unit_use > 0)
			{
				if (PromptCreatureUse(g_player,area))
					monster = true;
				else
					monster = false;
			}
		}
	}







	//worsen relations if different factions
	if (areas[area].owner != areas[target].owner && areas[target].owner > -1)
	{
		factions[areas[target].owner].hate[areas[area].owner] += amount;
		factions[areas[area].owner].hate[areas[target].owner] += Math.floor(amount/2);
	}

	var pgold = areas[target].gold;

	if (areas[target].owner > -1)
	{
		amount = DoBattle(amount, area, target,true, monster, monsterd);
	
		if (g_raid==1)
			PromptOverDisplay(area, target, "Raid succeeded.");
		else if (g_raid == 0)
			PromptOverDisplay(area, target, "Raid repelled.");
	}
	else
	{
		PromptOverDisplay(area, target, "Province occupied.");
		//just occupy it
		areas[target].owner = areas[area].owner;
		areas[target].sold = amount;
	}	
}



function SendGold(amount, area, target)
{
	OverDisplay(areas[area].name+" send "+amount+" gold to "+areas[target].name+".",area);

	if (amount < 0 || areas[area].owner == -1 || areas[target].owner == -1)
		return;

	if (areas[area].gold < amount)
		amount = areas[area].gold;
	amount = Math.floor(amount);
		
	areas[area].gold-=amount;
	areas[target].gold+=amount;
	
	if (areas[target].gold > gold_max)
		areas[target].gold = gold_max;

	//improve relations if different factions
	if (areas[area].owner != areas[target].owner)
	{
		factions[areas[target].owner].hate[areas[area].owner] -= amount;
		factions[areas[area].owner].hate[areas[target].owner] -= Math.floor(amount/2);

	}
}

function SendFood(amount, area, target)
{
	OverDisplay(areas[area].name+" send "+amount+" food to "+areas[target].name+".",area);

	if (amount < 0 || areas[area].owner == -1 || areas[target].owner == -1)
		return;

	if (areas[area].food < amount)
		amount = areas[area].food;
	amount = Math.floor(amount);
		
	areas[area].food-=amount;
	areas[target].food+=amount;
	
	if (areas[target].food > food_max)
		areas[target].food = food_max;

	//improve relations if different factions
	if (areas[area].owner != areas[target].owner)
	{
		factions[areas[target].owner].hate[areas[area].owner] -= amount;
		factions[areas[area].owner].hate[areas[target].owner] -= Math.floor(amount/2);
	}

}


function InputAmount(type, area)
{
	var bg = GrabImage(0,0,320,240);
	var string = "How much? (Max "+areas[area][type]+"): ";

	var amt = 0;
	var max = areas[area][type];
	if (max >= 9999)
	  max = 9999;
	
	var aamt = new Array();
	var place = 0;
	
	for (ii=0;ii<5;ii++)
	{
		aamt[ii] = 0;
	}	
	
	function SeeIfMaxed()
	{
		var amount = aamt[3]*1000+aamt[2]*100+aamt[1]*10+aamt[0];
	
		if (amount < max)
			return false;
		else
		{
			aamt[0] = max%10;
			aamt[1] = Math.floor((max%100)/10);
			aamt[2] = Math.floor((max%1000)/100);
			aamt[3] = Math.floor((max%10000)/1000);
			
			if (aamt[3] != 0)
				place = 4;
			else if (aamt[2] != 0)
				place = 3;
			else if (aamt[1] != 0)
				place = 2;
			else if (aamt[0] != 0)
				place = 1;
			else
				place = 0;
			
			return true;
		}
	}
	
	var tstring = "";
	
	while(true)
	{
		tstring = "";
		for (ii=0;ii<place;ii++)
		{
			tstring = aamt[ii]+tstring;
		}
		if (tstring == "")
			tstring = 0;

		bg.blit(0,0);
		window.drawWindow(16,240-16,320-192+64,5);
		font.drawText(17,240-16-3, string+tstring);
		FlipScreen();
		
		while(AreKeysLeft())
		{
			switch (GetKey())
			{
				case KEY_ESCAPE:
				{
					bg.blit(0,0);
					return -1;
				}
				case KEY_ENTER:
				{
					amt=aamt[3]*1000+aamt[2]*100+aamt[1]*10+aamt[0];
					if (amt <= max)
					{
						bg.blit(0,0);
						return amt;
					}
					else
					{
						//return error message
						break;
					}
				}
				case KEY_BACKSPACE:
				{
					for (ii=0;ii<3;ii++)
					{
						aamt[ii] = aamt[ii+1];		
					}
					aamt[3] = 0;
					place--;
					if (place < 0)
					  place = 0;
					break;
				}
				case KEY_0:
				{
					if (place != 0)
					{
						for (ii=place;ii>0;ii--)
						{
							aamt[ii]=aamt[ii-1];
						}
						aamt[0] = 0;
						place++;
					
						SeeIfMaxed();
					}
					break;
				}
				case KEY_1:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 1;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_2:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 2;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_3:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 3;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_4:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 4;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_5:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 5;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_6:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 6;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_7:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 7;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_8:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 8;
					place++;
				
					SeeIfMaxed();
					break;
				}
				case KEY_9:
				{
					for (ii=place;ii>0;ii--)
					{
						aamt[ii]=aamt[ii-1];
					}
					aamt[0] = 9;
					place++;
				
					SeeIfMaxed();
					break;
				}
			}
		}
	}
}

function MapRetreat(area, sold)
{
	for (m=0;m<num_areas;m++)
	{
		if (areas[area].boundary[m] == 1)
		{
			if (areas[area].owner == areas[m].owner)
			{
				areas[m].sold+=sold;
				return m;
			}
		}
	}
}

function BuyFood(area, amount)
{
	OverDisplay(areas[area].name+" buys "+amount+" food.",area);

	if (amount < 0)
		return;

	if (amount > areas[area].gold)
		amount = areas[area].gold;
	amount = Math.floor(amount);
	var food = Math.round(amount/g_price);
	areas[area].gold -= amount;
	areas[area].food+=food;
}

function SellFood(area, amount)
{
	OverDisplay(areas[area].name+" sell "+amount+" food.",area);

	if (amount < 0)
		return;

	if (amount > areas[area].food)
		amount = areas[area].food;
	amount = Math.floor(amount);
	var gold = Math.round(amount*g_price);
	areas[area].gold += gold;
	areas[area].food-=amount;
}

function OverDisplay(message, area)
{
	return;
	if (area != undefined)
		DrawMap(area);
	else
		DrawMap();
		
	font.drawText(0,0, message);
	FlipScreen();
	while(AreKeysLeft())
		GetKey();
	GetKey();
}


function DesiredFort(area)
{
	var ccount = 0
	for (df=0;df<num_areas;df++)
	{
		if (areas[area].boundary[df] == 1)
			ccount++;
	}

	var rval = 30+ccount*30;
	return rval;
}

function AutoDistribute(area)
{
	var acount = 0;

	var g_amount = 0;
	if (areas[area].auto_gold == 0)
		g_amount = 0;
	else if (areas[area].auto_gold == 1)
		g_amount = Math.floor(areas[area].gold/8);
	else if (areas[area].auto_gold == 2)
		g_amount = Math.floor(areas[area].gold/4);
	else if (areas[area].auto_gold == 3)
		g_amount = Math.floor(areas[area].gold/2);

	var f_amount = 0;
	if (areas[area].auto_food == 0)
		f_amount = 0;
	else if (areas[area].auto_food == 1)
		f_amount = Math.floor(areas[area].food/8);
	else if (areas[area].auto_food == 2)
		f_amount = Math.floor(areas[area].food/4);
	else if (areas[area].auto_food == 3)
		f_amount = Math.floor(areas[area].food/2);

	for (ad=0;ad<num_areas;ad++)
	{
		if (areas[area].boundary[ad] == 1 && area!=ad)
		{
			if (areas[area].owner == areas[ad].owner)
			{
				acount++;
			}
		}
	}
	
	for (ad=0;ad<num_areas;ad++)
	{
		if (areas[area].boundary[ad] == 1 && area!=ad)
		{
			if (areas[area].owner == areas[ad].owner)
			{
				SendFood(Math.floor(f_amount/acount), area, ad);
				SendGold(Math.floor(g_amount/acount), area, ad);
			}
		}
	}
}



function PromptOverDisplay(area1, area2, string)
{
	var bgc2 = CreateColor(0,94,138,255);
	var lasttime = GetTime();
	var frametime = 1000/30;

	var framesy = 0;
	ml_pressed = true;
	
	while(framesy < 60)
	{
		Rectangle(0,0,320,240,bgc);
		DrawMap();
		if (area1 > -1)
		{
			if (areas[area1].owner>-1)
			{
				(areas[area1].image).blitMask(320-192,0, CreateColor((factions[areas[area1].owner].colour).red, (factions[areas[area1].owner].colour).green, (factions[areas[area1].owner].colour).blue, 255));

				if (area2>-1)
				{
					if (areas[area2].owner > -1)
						(areas[area2].image).blitMask(320-192,0, CreateColor((factions[areas[area2].owner].colour).red, (factions[areas[area2].owner].colour).green, (factions[areas[area2].owner].colour).blue, 255));
					else
						(areas[area2].image).blitMask(320-192,0, CreateColor(255,255,255, 255));
				}

				g_map_bound.blit(320-192,0);
			}
		}
		window.drawWindow(16,16,320-192-32+10,240-48);
		
		font.drawTextBox(16,14+18, 320-192-32+10,120,0,string);
		DrawRound();
		g_mouse.blit(GetMouseX(),GetMouseY());
		while(GetTime()-lasttime < frametime);
		lasttime= GetTime();
		FlipScreen();
		framesy++;

		if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
		{
			ml_pressed = true;
			return;
		}

		if (!IsMouseButtonPressed(MOUSE_LEFT))
			ml_pressed = false;
		

		while(AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_ESCAPE:
				{
					return;
				}
				case KEY_ENTER:
				{
					return;
				}
				case KEY_SPACE:
				{
					return;
				}
			}
		}
	}
}

function FadeOverOut(string1)
{
	var bgc2 = CreateColor(0,94,138,255);
	var lasttime = GetTime();
	var frametime = 1000/30;

	ml_pressed = true;
	var fade = 0;
	var fade_max = 64;
	
	while(fade < fade_max)
	{
		if (string1 != "in")
			FadeMusic(fade/fade_max);

		Rectangle(0,0,320,240,bgc);
		DrawMap();

		window.drawWindow(16,16,320-192-32+10,240-48);
		DrawRound();
		g_mouse.blit(GetMouseX(),GetMouseY());
		while(GetTime()-lasttime < frametime);
		lasttime= GetTime();
		if (string1 == "in")
			Rectangle(0,0,320,240,CreateColor(0,0,0,255-fade*(255/fade_max)));
		else
			Rectangle(0,0,320,240,CreateColor(0,0,0,fade*(255/fade_max)));
		FlipScreen();
		fade++;
	}
	if (string1 != "in")
		FlipScreen();
}


function FadeInOverDisplay()
{
	var bgc2 = CreateColor(0,94,138,255);
	var lasttime = GetTime();
	var frametime = 1000/30;

	ml_pressed = true;
	var fade = 0;
	var fade_max = 64;
	
	while(fade < fade_max)
	{
		Rectangle(0,0,320,240,bgc);
		DrawMap();

		window.drawWindow(16,16,320-192-32+10,240-48);
		DrawRound();
		g_mouse.blit(GetMouseX(),GetMouseY());
		while(GetTime()-lasttime < frametime);
		lasttime= GetTime();
		Rectangle(0,0,320,240,CreateColor(0,0,0,255-fade*(255/fade_max)));
		FlipScreen();
		fade++;
	}
}